/*
  */

#include <stdio.h>
#include "pocket.h"

#define CLRSCR "\033[;H\033[2J"
#define CURHOME "\033[;H"

#define LCDX1 (5 * 12)
#define LCDX2 (5 * 16)

#define LCD1 0x7000
#define LCD2 0x703c
#define LCD3 0x7068
#define LCD4 0x707c

#define ROMFONT 0x806c

#define EOS '\0'

/* #define XMAX 80 */
#define XMAX 96		/* 96ɥå */

/* 5ȤǰʸȤ˶ */
#define log2phy(x) ((x) + (x) / 5)

/* ɥ쥹xɸѴ */
#define add2x(a) \
    (((a) < LCD2) ? ((a) - LCD1) : (LCD4 - 1 - (a) + 60))

/* xɸ饢ɥ쥹Ѵ */
#define x2add(x) \
    (((x) < (LCD2 - LCD1)) ? ((x) + LCD1) : (LCD4 - (x) + LCD1 - LCD2))

#define showbyadd(a) {int x; x = add2x(a); showone(log2phy(x), mainram[a]);}


int lcdmem(int x)
{
    if (x % 6 == 5) {
	return(0);
    }
    x = x - (x / 6);	/* ɽɸŪʺɸѴ */
    if (x < LCDX1) {
	return(mainram[LCD1 + x]);
    }
    else {
	return(mainram[LCD3 + (LCDX2 - x - 1)]);
    }
}


/* static int a2x[100]; */
static int x2a[100];

void lcdinit()
{
    int x;
    
    /* xɸȥꥢɥ쥹бɽκ */
    for (x = 0; x < LCDX1; x++) {
	x2a[x] = LCD1 + x;
    }
    for (x = LCDX1; x < LCDX2; x++) {
	x2a[x] = LCD3 + (LCDX2 - x - 1);
    }
}

char *sym1[] = {"KANA", "S/K", "SML", "STAT"};
char *sym2[] = {"BUSY", "DEF", "SHIFT", "HYP", "PRO", "RUN", "CAL"};
char *sym3[] = {"E", "M", "()", "RAD", "G", "DE", "PRINT"};
#define SYM1 0x703c
#define SYM2 0x703d
#define SYM3 0x707c

void symdisptop()
{
    int i, j;

    j = 1;
    for (i = 0; i < 4; i++) { /* BUSY DEF SHIFT HYP */
	printf("%-5s ", (mainram[SYM2] & j) ? sym2[i] : "");
	j *= 2;
    }
    j = 1;
    for (i = 0; i < 3; i++) { /* KANA S/K SML */
	printf("%-4s ", (mainram[SYM1] & j) ? sym1[i] : "");
	j *= 2;
    }
    j = 1;
    for (i = 0; i < 3; i++) { /* E M () */
	printf("%-3s ", (mainram[SYM3] & j) ? sym3[i] : "");
	j *= 2;
    }
    printf("%-2s", (mainram[SYM3] & 0x20) ? sym3[5] : "");	/* DE */
    printf("%-1s", (mainram[SYM3] & 0x10) ? sym3[4] : "");	/* G */
    printf("%-3s ", (mainram[SYM3] & 0x08) ? sym3[3] : "");	/* RAD */
    printf("\r\n");
}


void symdispbot()
{
    int i, j;

    j = 0x40;
    for (i = 6; i > 3; i--) { /* CAL RUN PRO */
	printf("%-3s ", (mainram[SYM2] & j) ? sym2[i] : "");
	j >>= 1;
    }
    printf("     ");
    printf("%-4s ", (mainram[SYM1] & 0x08) ? sym1[3] : "");	/* STAT */
    printf("%-5s\r\n", (mainram[SYM3] & 0x40) ? sym3[6] : "");	/* PRINT */
}


char lcdtochar(int addr)
{
    int i;
    int ch;

    for (ch = 0x20; ch < 0x7f; ch++) {
	for (i = 0; i < 5; i++) {
	    if (mainram[ROMFONT + (ch - 0x20) * 5 + (4 - i)]
		!= mainram[addr + i]) {
		break;
	    }
	}
	if (i >= 5) {
	    return(ch);
	}
    }
    return(' ');
}


char lcdtochar2(int addr)
{
    int i;
    int ch;

    for (ch = 0x20; ch < 0x7f; ch++) {
	for (i = 0; i < 5; i++) {
	    if (mainram[ROMFONT + (ch - 0x20) * 5 + i] != mainram[addr + i]) {
		break;
	    }
	}
	if (i >= 5) {
	    return(ch);
	}
    }
    return(' ');
}


char *lcdtostr()
{
    int i;
    int addr;
    static char s[17];
    
    for (i = 0; i < 12; i++) {
	addr = 5 * i + LCD1;
	s[i] = lcdtochar(addr);
    }
    for (i = 12; i < 16; i++) {
	addr = LCD4 + 5 * (11 - i);
	s[i] = lcdtochar2(addr);
    }
    s[i] = EOS;
    return(&s[0]);
}


void clearall()
{
    printf(CLRSCR);
}


void displayall()
{
    int x;
    int y;
    int b;
    int c;
    int p;
    int q;
    unsigned char hi, lo;

    printf(CURHOME);
    symdisptop();
    for (y = 0; y < 2; y++) {
	for (x = 0; x < XMAX; x += 2) {
	    /* c = 0x500; */
	    c = 0x200;
	    q = 1;
	    b = 1 << (y * 4);
	    for (p = 0; p < 4; p++) {
		if ((lcdmem(x) & b) != 0) {
		    c |= q;
		}
		if ((lcdmem(x + 1) & b) != 0) {
		    c |= (q << 4);
		}
		q *= 2;
		b *= 2;
	    }
	    /* UTF-8󥳡ǥ󥰤1ʸ (2Х) ɽ */
	    /* U+0080 .. U+07FF -> 110yyyxx 10xxxxxx */
	    /*                     76543210 76543210 */
	    /* 0x500 -> 0101 0000 0000 */
	    /*             1 0100  000 0000 */
	    /*          1100 0000 1000 0000 */
	    /*       -> 1101 0100 1000 0000 */ 
	    hi = ((c & 0x07fc) >> 6) | 0x00c0;
	    lo = (c & 0x003f) | 0x0080;
	    putchar(hi);
	    putchar(lo);
	}
	putchar('\r');
	putchar('\n');
    }
    symdispbot();
    printf("\r\n%s\r\n\n", lcdtostr());
}

void busy()
{
    printf(CURHOME);
    printf("BUSY\r");
}




#ifdef MAIN
main()
{
    int x;
    
    lcdinit();
    for (x = 0; x < 80; x++) {
	printf("%04x ", x2a[x]);
	if (x % 5 == 4) {
	    putchar('\n');
	}
    }
}
#endif
